VERSION 5.00
Begin VB.Form frmDetectLockedWorkstation 
   Caption         =   "Form1"
   ClientHeight    =   1980
   ClientLeft      =   210
   ClientTop       =   2385
   ClientWidth     =   2610
   LinkTopic       =   "Form1"
   ScaleHeight     =   1980
   ScaleWidth      =   2610
   Begin VB.CommandButton cmdStopMonitoring 
      Caption         =   "Stop Monitoring"
      Height          =   525
      Left            =   458
      TabIndex        =   2
      Top             =   1358
      Width           =   1695
   End
   Begin VB.CommandButton cmdJustMonitor 
      Caption         =   "Just Monitor"
      Height          =   525
      Left            =   458
      TabIndex        =   1
      Top             =   728
      Width           =   1695
   End
   Begin VB.Timer Timer1 
      Left            =   30
      Top             =   1470
   End
   Begin VB.CommandButton cmdLockWorkstation 
      Caption         =   "Lock Workstation"
      Height          =   525
      Left            =   458
      TabIndex        =   0
      Top             =   98
      Width           =   1695
   End
End
Attribute VB_Name = "frmDetectLockedWorkstation"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private IsW2kPlus As Boolean

Private Declare Sub LockWorkstation _
   Lib "User32.dll" Alias "LockWorkStation" ()
Private Declare Function SwitchDesktop _
   Lib "user32" _
   (ByVal hDesktop As Long) As Long
Private Declare Function OpenDesktop _
   Lib "user32" Alias "OpenDesktopA" _
   (ByVal lpszDesktop As Any, _
    ByVal dwFlags As Long, _
    ByVal fInherit As Long, _
    ByVal dwDesiredAccess As Long) As Long
Private Declare Function CloseDesktop _
   Lib "user32" _
   (ByVal hDesktop As Long) As Long
Private Declare Function SystemParametersInfo _
   Lib "user32" Alias "SystemParametersInfoA" _
   (ByVal uiAction As Long, _
    ByVal uiParam As Long, _
    ByRef pvParam As Any, _
    ByVal fWinIni As Long) As Long
Private Declare Function GetVersionEx _
   Lib "kernel32" Alias "GetVersionExA" _
   (lpVersionInformation As OSVERSIONINFO) As Long
Private Type OSVERSIONINFO
   dwOSVersionInfoSize                 As Long
   dwMajorVersion                      As Long
   dwMinorVersion                      As Long
   dwBuildNumber                       As Long
   dwPlatformId                        As Long
   szCSDVersion                        As String * 128
End Type

Private Const SPI_GETSCREENSAVERRUNNING   As Long = 114&

Private Const DESKTOP_READOBJECTS         As Long = &H1
Private Const DESKTOP_CREATEWINDOW        As Long = &H2
Private Const DESKTOP_CREATEMENU          As Long = &H4
Private Const DESKTOP_HOOKCONTROL         As Long = &H8
Private Const DESKTOP_JOURNALRECORD       As Long = &H10
Private Const DESKTOP_JOURNALPLAYBACK     As Long = &H20
Private Const DESKTOP_ENUMERATE           As Long = &H40
Private Const DESKTOP_WRITEOBJECTS        As Long = &H80
Private Const DESKTOP_SWITCHDESKTOP       As Long = &H100

Private Sub cmdLockWorkstation_Click()
   
   Me.Timer1.Enabled = False
   Me.Timer1.Interval = 3000
   Me.Timer1.Enabled = True
   
   LockWorkstation

End Sub

Private Sub cmdJustMonitor_Click()
   
   Me.Timer1.Enabled = False
   Me.Timer1.Interval = 3000
   Me.Timer1.Enabled = True
   
End Sub

Private Sub cmdStopMonitoring_Click()

   Me.Timer1.Enabled = False

End Sub

Private Sub Form_Load()
   Dim p_lngMajorVer                   As Long
   Dim p_typOsVersionInfo              As OSVERSIONINFO
   
   ' ------------------------------------------
   ' Set the length and make API call
   ' ------------------------------------------
   p_typOsVersionInfo.dwOSVersionInfoSize = Len(p_typOsVersionInfo)
   GetVersionEx p_typOsVersionInfo
   
   ' ------------------------------------------
   ' Get the details
   ' ------------------------------------------
   p_lngMajorVer = p_typOsVersionInfo.dwMajorVersion
   If p_lngMajorVer >= 5 Then
      IsW2kPlus = True
   Else
      IsW2kPlus = False
   End If
   
End Sub

Private Sub Timer1_Timer()
   Dim p_lngHwnd                       As Long
   Dim p_lngRtn                        As Long
   Dim p_lngErr                        As Long
   Dim p_lngScreenSaver                As Long
   Dim p_blnIsScreenSaver              As Boolean
   
   ' ------------------------------------------
   ' First check for screen saver one of 2 ways,
   '     based of OS
   ' ------------------------------------------
   If IsW2kPlus = False Then
      ' ---------------------------------------
      ' Pre W2K -- Note, will only be TRUE if
      '     the "Password Protected" box is
      '     checked.
      ' ---------------------------------------
      p_lngHwnd = OpenDesktop(lpszDesktop:="screen-saver", _
                              dwFlags:=0, _
                              fInherit:=False, _
                              dwDesiredAccess:=DESKTOP_ENUMERATE)
      If p_lngHwnd <> 0 Then
         p_blnIsScreenSaver = True
      Else
         p_blnIsScreenSaver = False
      End If
   Else
      ' ---------------------------------------
      ' W2K+ -- Will determine if screen saver
      '     is running whether or not the
      '     "Password Protected" box is checked
      ' ---------------------------------------
      p_lngRtn = SystemParametersInfo(uiAction:=SPI_GETSCREENSAVERRUNNING, _
                                      uiParam:=0&, _
                                      pvParam:=p_lngScreenSaver, _
                                      fWinIni:=0&)
      If p_lngRtn = 0 Then
         Debug.Print Err.LastDllError
      Else
         p_blnIsScreenSaver = CBool(p_lngScreenSaver)
      End If
      
   End If
   
   ' ------------------------------------------
   ' If screen saver is *not* running, then
   '     check for locked workstation
   ' ------------------------------------------
   If p_blnIsScreenSaver = True Then
      If IsW2kPlus = False Then
         Debug.Print "Screen saver is running..., Handle #" & p_lngHwnd
         p_lngHwnd = CloseDesktop(p_lngHwnd)
      Else
         Debug.Print "Screen saver is running on W2K+"
      End If
      
   Else
      p_lngHwnd = OpenDesktop(lpszDesktop:="Default", _
                              dwFlags:=0, _
                              fInherit:=False, _
                              dwDesiredAccess:=DESKTOP_SWITCHDESKTOP)
      
      If p_lngHwnd = 0 Then
         Debug.Print "Error with OpenDesktop: " & Err.LastDllError
   
      Else
         p_lngRtn = SwitchDesktop(hDesktop:=p_lngHwnd)
         p_lngErr = Err.LastDllError
         
         If p_lngRtn = 0 Then
            If p_lngErr = 0 Then
               Debug.Print "Desktop is locked: " & Err.LastDllError
            Else
               Debug.Print "Error with SwitchDesktop: " & Err.LastDllError
            End If
         Else
            Debug.Print "Not locked!"
         End If
      
         p_lngHwnd = CloseDesktop(p_lngHwnd)
   
      End If
   End If
   
End Sub
